/*
 * Copyright (C) 2008 Tony Wasserka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 *
 */

class CBullet
{
public:
    CBullet(float _x, float _y, float _vx, float _vy, int _col) : x(_x), y(_y), vx(_vx), vy(_vy), col(_col), next(NULL) {};
    ~CBullet();

    int logic(BITMAP *terrain, CParticleManager *particleman, CPlayer *players);
    void draw(BITMAP *buffer);

    CBullet *next; /* If I was familiar with using friends, this would be private and a friend of CBulletManager :/ */

private:
    float x, y;
    float vx, vy;
    int col;
};

class CBulletManager
{
public:
    CBulletManager();
    ~CBulletManager();

    void logic(BITMAP *terrain, CParticleManager *particleman, CPlayer *players);
    void draw(BITMAP *buffer);

    void attach(CBullet *bullet);
    void remove(CBullet *bullet);
private:
    CBullet *root;
};
