/*
 * Copyright (C) 2008 Tony Wasserka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 *
 */

#include <allegro.h>
#include "dialog.h"
#include "global.h"

CGameDialog::CGameDialog(int duration, const char *_header, const char *_line1, const char *_line2, const char *_line3, const char *_line4)
{
    strcpy(header, _header);
    strcpy(line1, _line1);
    strcpy(line2, _line2);
    strcpy(line3, _line3);
    strcpy(line4, _line4);

    count=duration;

    log("Created dialog\n");
}

CGameDialog::~CGameDialog()
{
    log("Deleted dialog\n");
}

int CGameDialog::logic()
{
    return !(--count);
}

void CGameDialog::draw(BITMAP *buffer)
{
    rectfill(buffer, 100, 40, SCREEN_W-100, 110, makecol(255, 255, 255));
    rectfill(buffer, 110, 50, SCREEN_W-110, 100, makecol(0, 0, 0));

    textprintf_centre_ex(buffer, font, 200, 30, makecol(255, 255, 255), -1, "The creator says...");
    textprintf_centre_ex(buffer, font, SCREEN_W/2, 50, makecol(255, 255, 255), -1, header);
    textprintf_centre_ex(buffer, font, SCREEN_W/2, 60, makecol(255, 255, 255), -1, line1);
    textprintf_centre_ex(buffer, font, SCREEN_W/2, 70, makecol(255, 255, 255), -1, line2);
    textprintf_centre_ex(buffer, font, SCREEN_W/2, 80, makecol(255, 255, 255), -1, line3);
    textprintf_centre_ex(buffer, font, SCREEN_W/2, 90, makecol(255, 255, 255), -1, line4);
}
