/*
 * Copyright (C) 2008 Tony Wasserka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 *
 */

/* Things which are needed for internal application behavior */

#define INIT_SUCCESS 0
#define INIT_FAIL 1

#define ENDLOOP_QUIT 0
#define ENDLOOP_ERROR 1

class CApplication
{
public:
    CApplication();
    ~CApplication();

    int init();
    void exit();
    int game_loop();

    void change_state(CGameState *new_state);
private:
    BITMAP *buffer;
    CGameState *state;
};

class CLogger
{
public:
    CLogger();
    ~CLogger();

    void log(char *str);
private:
    FILE *file; /* I hate C++ I/O, looks to ugly... */
};
