/*
 * Copyright (C) 2008 Tony Wasserka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 *
 */

class CParticle
{
public:
    CParticle(float _x, float _y, float _vx, float _vy, int _col) : x(_x), y(_y), vx(_vx), vy(_vy), col(_col), next(NULL) {};
    ~CParticle();

    int logic(BITMAP *terrain, CPlayer *players);
    void draw(BITMAP *buffer);

    CParticle *next; /* If I was familiar with using friends, this would be private and a friend of CParticleManager :/ */

private:
    float x, y;
    float vx, vy;
    int col;
};

class CPlayer;
class CParticleManager
{
public:
    CParticleManager();
    ~CParticleManager();

    void logic(BITMAP *terrain, CPlayer *players);
    void draw(BITMAP *buffer);
    void explode(BITMAP *terrain, int x, int y, float xv, float yv, float strength, CPlayer *players);

    void attach(CParticle *particle);
    void remove(CParticle *particle);
private:
    CParticle *root;
};
