/*
 * Copyright (C) 2008 Tony Wasserka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 *
 */

class CPlayer
{
public:
    CPlayer();
    ~CPlayer();

    void init(int px, int py);
    void exit();
    void logic(BITMAP *terrain, CBulletManager *bulletman, CPlayer *other, int own_number);
    void draw(BITMAP *buffer);
    void set_controls(int left, int right, int up, int down, int jump, int shot);
    void hit(int strength);
    void toggle_ai(bool use_ai);

    float x, y; /* LEARN HOW TO STRUCTURE YOUR CODE PROPRERLY DAMNIT */
    int dmg, dmgcount;
    int health;
private:
    float xv, yv;
    int dir;
    float angle;
    bool jumping;
    int shooting;
    int keyleft, keyright, keyup, keydown, keyjump, keyshot;
    int power;
    int reload;
    bool ai;
    int replay, replayground;
};
